include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460.0]download[/url]
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.data
v1	REAL4 123.450
v2	REAL8 123.452
v3	REAL10 123.454
v4	QWORD 12345678
v5	REAL4 123.458

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	100	; get a fresh time slice
	LOOP_COUNT =	1000000
	REPEAT 2
		invoke Sleep, SleepMs
		NanoTimer()
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 2
			cmp eax, edx
			nop
			cmp ecx, ebx
			nop
			cmp esi, edi
			nop
			cmp edx, eax
			nop
			cmp ebx, ecx
			nop
		ENDM
		counter_end
		Print Str$("%i\tcycles for 10*cmp\t", eax), Str$("%i ms   \tfor ", NanoTimer(ms)), Str$("%i comparisons\n", 10*LOOP_COUNT)

		invoke Sleep, SleepMs
		NanoTimer()
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 2
			Fcmp v1, v2	; Real4 vs Real8
			nop
			Fcmp eax, v3	; reg32 vs Real10
			nop
			Fcmp v4, ecx	; QWord vs reg32
			nop
			Fcmp xmm0, v5	; xmm vs REAL4
			nop
			Fcmp eax, xmm1	; reg32 vs xmm
			nop
		ENDM
		counter_end
		Print Str$("%i\tcycles for 10*Fcmp\t", eax), Str$("%i ms\tfor ", NanoTimer(ms)), Str$("%i comparisons\n", 10*LOOP_COUNT)

	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
7       cycles for 10*cmp       5 ms    for 10000000 comparisons
1343    cycles for 10*Fcmp      399 ms  for 10000000 comparisons
6       cycles for 10*cmp       5 ms    for 10000000 comparisons
1326    cycles for 10*Fcmp      395 ms  for 10000000 comparisons